using System.IO;
using UnityEngine;

public class SimpleMeshGenerator : MonoBehaviour
{
    /// <summary>
    /// oCitH[}bgSTLt@CǂݍMeshŕԂ
    /// </summary>
    /// <param name="path">STLt@C̃tpX</param>
    /// <returns>bVf[^</returns>
    private Mesh StlToUnityMesh(string path)
    {
        var stream = File.OpenRead(path);
        var reader = new BinaryReader(stream);

        // "Cӂ̕"ǂݔ΂
        stream.Position = 80;

        // "Op`̖"ǂݍ
        uint triangleNum = reader.ReadUInt32();

        Vector3[] vert = new Vector3[triangleNum * 3];
        int[] tri = new int[triangleNum * 3];

        int triangleIndex = 0;

        for (int i = 0; i < triangleNum; i++)
        {
            // "@xNg"ǂݔ΂
            stream.Position += 12;
            // "_"f[^X, Y, Z3
            vert[triangleIndex + 0] = new Vector3(reader.ReadSingle(), reader.ReadSingle(), reader.ReadSingle());
            vert[triangleIndex + 1] = new Vector3(reader.ReadSingle(), reader.ReadSingle(), reader.ReadSingle());
            vert[triangleIndex + 2] = new Vector3(reader.ReadSingle(), reader.ReadSingle(), reader.ReadSingle());

            // _ԎOp`́AقǓǂݍ񂾒_ԍ̂܂܎g
            tri[triangleIndex] = triangleIndex++;
            tri[triangleIndex] = triangleIndex++;
            tri[triangleIndex] = triangleIndex++;

            // "gpf[^"ǂݔ΂
            stream.Position += 2;
        }

        var mesh = new Mesh();
        mesh.vertices = vert;
        mesh.triangles = tri;
        mesh.RecalculateNormals();
        mesh.RecalculateBounds();

        return mesh;
    }

    void Start()
    {
        string filePath = Path.Combine(Application.dataPath, "ufo.stl");
        GetComponent<MeshFilter>().mesh = StlToUnityMesh(filePath);
    }

}
