using System;
using System.Collections;
using System.Collections.Generic;
using Unity.VisualScripting;
using UnityEngine;

namespace enemy
{
    public class Bullet : MonoBehaviour
    {
        private Vector3 vel;

        public void Initialize(Vector3 pos, Vector3 vel)
        {
            this.vel = vel;
            transform.position = pos;
        }

        private void Update()
        {
            transform.position += vel * Time.deltaTime; // ړ

            // ʊOɏo
            if (!IsInViewport())
            {
                Destroy(gameObject);
            }
        }

        // IuWFNgʓɂ邩ǂ𔻒肷郁\bh
        private bool IsInViewport()
        {
            Vector3 viewportPosition = Camera.main.WorldToViewportPoint(transform.position);
            return viewportPosition.x >= 0 && viewportPosition.x <= 1 && viewportPosition.y >= 0 && viewportPosition.y <= 1;
        }
    }
    public class Enemy : MonoBehaviour
    {
        protected BulletManager bm;

        protected float time = 0;
        private float startTime = 2;//2b܂ł͓Ȃ
        private float startTimer = 0;

        public float intervalTime=1;

        protected void Initialize(float intervalTime)
        {
            this.intervalTime = intervalTime;
        }

        // Start is called before the first frame update
        virtual protected void Start()
        {
            Vector3 pos = transform.position;
            pos.x = UnityEngine.Random.Range(-15.0f, 15.0f);
            pos.y = UnityEngine.Random.Range(-8.0f, 8.0f);
            transform.position = pos;

            bm = GameObject.Find("BulletManager").GetComponent<BulletManager>();

            time = intervalTime - 0.01f;

            if (intervalTime <= 0) { throw new Exception("intervalTime0傫Ă"); }
        }

        protected void UpdateTimer()
        {
            if(startTime<startTimer)
            {
                time += Time.deltaTime;
            }
            else
            {
                startTimer += Time.deltaTime;
            }
        }
        public void Shot(float velX,float velY)
        {
            bm.Add(transform.position, velX, velY);
        }

        public void ResetEnemy()
        {
            time = intervalTime - 0.01f;
            startTimer = 0;
        }
    }
    //_
    public class Enemy1 : Enemy
    {
        private Transform player;
        public float bulletSpeed;

        protected override void Start()
        {
            base.Start();
            player = GameObject.Find("Player").GetComponent<Transform>();
        }

        // Update is called once per frame
        void Update()
        {
            UpdateTimer();

            while (time > intervalTime)
            {
                time -= intervalTime;
                var dir = player.position - transform.position;
                dir.Normalize();
                dir *= bulletSpeed;
                Shot(dir.x, dir.y);
            }
        }
    }
    //]
    public class Enemy2 : Enemy
    {
        private float dir;//x
        public float bulletSpeed;
        public float rotationSpeed;
        public int numArm;

        public void Initialized(int ArmNum, float rotationSpeed, float bulletSpeed,float interval,float dir=0)
        {
            base.Initialize(interval);
            this.numArm = ArmNum;
            this.rotationSpeed = rotationSpeed;
            this.bulletSpeed = bulletSpeed; 
            this.dir = dir;
        }
        // Update is called once per frame
        void Update()
        {
            UpdateTimer();
            dir += rotationSpeed * Time.deltaTime;

            while (time > intervalTime)
            {
                time -= intervalTime;

                for(int i = 0; i < numArm; i++)
                {
                    dir += 360/numArm;

                    Shot(MathF.Cos(dir / 180 * MathF.PI) * bulletSpeed, MathF.Sin(dir / 180 * MathF.PI) * bulletSpeed);
                }
            }
            dir %= 360f;
        }
    }
    //ǂ 
    public class Oikake : MonoBehaviour
    {
        private Transform player;
        public float g = 0;//
        private Vector3 vel;
        public float maxv = 2f;

        void Start()
        {
            player = GameObject.Find("Player").GetComponent<Transform>();
            vel = new Vector3(0, 0, 0);
        }

        // Update is called once per frame
        void Update()
        {
            var dir = (player.transform.position - transform.position);
            dir.Normalize();
            vel += g * dir * Time.deltaTime;
            if (vel.sqrMagnitude > maxv * maxv) 
            {
                vel.Normalize();
                vel *= maxv;
            }
            TMove(vel.x, vel.y);//vC[̕
        }
        public void TMove(float velX, float velY)
        {
            var dt = Time.deltaTime;
            if (IsOutsideViewport(transform.position + new Vector3(velX * dt, 0, 0))) velX = 0;
            if (IsOutsideViewport(transform.position + new Vector3(0, velY * dt, 0))) velY = 0;

            if (!(velX == 0 && velY == 0)) transform.position += new Vector3(velX, velY, 0) * dt;
        }
        private bool IsOutsideViewport(Vector3 position)
        {
            Vector3 viewportPosition = Camera.main.WorldToViewportPoint(position);
            return viewportPosition.x < 0 || viewportPosition.x > 1 || viewportPosition.y < 0 || viewportPosition.y > 1;
        }
    }
    //g
    public class Enemy3 : Enemy
    {
        public float bulletSpeed;
        public int numArm;
        public float initDir;

        public void Initialized(int ArmNum, float bulletSpeed, float interval, float initDir = 0)
        {
            base.Initialize(interval);
            this.numArm = ArmNum;
            this.bulletSpeed = bulletSpeed;
            this.initDir = initDir;
        }
        // Update is called once per frame
        void Update()
        {
            UpdateTimer();

            while (time > intervalTime)
            {
                time -= intervalTime;

                for (int i = 0; i < numArm; i++)
                {
                    var dir = (float)i / numArm * 2 * MathF.PI + initDir;
                    Shot(MathF.Cos(dir) * bulletSpeed, MathF.Sin(dir) * bulletSpeed);
                }
            }
        }
    }

}